#!/usr/bin/python

import os
import sys
import hashlib
import base64
import string, random
from passlib.hash import md5_crypt as md5c
from passlib.hash import phpass as php
import binascii

chars = string.letters + string.digits

class sha1:
	def makepwd(self,length):
	    self.password = ""
	    for i in range(int(length)):
		self.password += random.choice(chars)
	    return self.password

	def makeSecret(self):
	    h = hashlib.sha1(self.password)
	    return h.hexdigest()
	
	def gettype(self):
	    return "sha1"

class md5:
	def makepwd(self,length):
	    self.password = ""
	    for i in range(int(length)):
		self.password += random.choice(chars)
	    return self.password

	def makeSecret(self):
	    h = hashlib.md5(self.password)
	    return h.hexdigest()
	
	def gettype(self):
	    return "md5"

class nt:
	def makepwd(self,length):
	    self.password = ""
	    for i in range(int(length)):
		self.password += random.choice(chars)
	    return self.password

	def makeSecret(self):
	    h =  hashlib.new('md4', self.password.encode('utf-16le')).digest()
	    return "$NT$" + binascii.hexlify(h)
	    
	def gettype(self):
	    return "nt"
	
class ssha:
	def getsalt(self,chars = string.letters + string.digits,length=8):
 	    self.salt = ""
	    for i in range(int(length)):
		self.salt += random.choice(chars)

	def makepwd(self,length):
	    self.password = ""
	    for i in range(int(length)):
		self.password += random.choice(chars)
	    return self.password

	def makeSecret(self):
	    self.getsalt()
	    h = hashlib.sha1(self.password)
	    h.update(self.salt)
	    return "{SSHA}" + base64.encodestring(h.digest() + self.salt).strip()

	def gettype(self):
	    return "ssha"

class cryptmd5:
      def makepwd(self,length=8):
	  self.password=""
	  for i in range(int(length)):
	     self.password+=random.choice(chars)
	  return self.password
	  
      def getsalt(self,length=8):
	  self.salt=""
	  for i in range(int(length)):
	      self.salt+=random.choice(chars)
	  return self.salt
	  
      def makeSecret(self):
	  h=md5c.encrypt(self.password,salt=self.getsalt())
	  return h
	 
      def gettype(self):
	  return "cryptmd5"
	  
class phpass:
      def makepwd(self,length=8):
	  self.password=""
	  for i in range(int(length)):
	      self.password+=random.choice(chars)
	  #print self.password
	  return self.password
      
      def getsalt(self):
	  self.salt=""
	  for i in range(8):
	      self.salt+=random.choice(chars)
	  #print self.salt
	  return self.salt
      
      def makeSecret(self):
	  h=php.encrypt(self.password,rounds=11,salt=self.getsalt())
	  #h=php.encrypt("abcdefgh",rounds=11,salt="saltstri")
	  return h

      def gettype(self):
	  return "phpass"
	  
class generator:
      def __init__(self):
	random.seed(42)
	
      def generate(self,size):
	crack = open('opencl-crack','w')
	self.passwords=[]

	for h in [sha1(),md5(),nt(),ssha(),phpass(),cryptmd5()]:
	  for i in range(size):
	    password = h.makepwd(random.randint(8,15))
	    self.passwords.append(password)
	    secret=h.makeSecret()
	    crypt = "%s:%s:%s"%(h.gettype()+'-'+str(i),secret,password)
	    crack.write(crypt+'\n')
	self.writePasswords()
	
      def writePasswords(self):
	wordlist = open('opencl-wordlist','w')
	#self.addTrash(len(self.passwords)*10)
	random.shuffle(self.passwords)
	for password in self.passwords:
	  wordlist.write(password+'\n')
	
      def addTrash(self,size):
	g = phpass()
	for i in range(size):
	  self.passwords.append(g.makepwd())

g = generator()
g.generate(int(sys.argv[1]))
#g=phpass()
#g.makepwd()
#print g.makeSecret()

#if sys.argv[1] == "ssha":
#	hg = ssha()
#elif sys.argv[1] == "sha1":
#	hg = sha1()
#elif sys.argv[1] == "md5":
#	hg = md5()
#elif sys.argv[1] == "nt":
#	hg = nt()
#elif sys.argv[1] == "cryptmd5":
#	hg = cryptmd5()
#elif sys.argv[1] == "phpass":
#	hg = phpass()
#x = 0
#while x < int(sys.argv[2]):
#	password = hg.makepwd(random.randint(8,15))
#	secret=hg.makeSecret()
#	print "%s:%s:%s"%(hg.gettype()+'-'+str(x),secret,password)
#	x = x+1
